Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoVRMLIndexedLineSet Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLIndexedLineSet.h>`

Inheritance diagram for SoVRMLIndexedLineSet:

List of all members.

## Detailed Description

The SoVRMLIndexedLineSet class is used to represent a generic 3D line shape.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      IndexedLineSet {
        eventIn       MFInt32 set_colorIndex
        eventIn       MFInt32 set_coordIndex
        exposedField  SFNode  color             NULL
        exposedField  SFNode  coord             NULL
        field         MFInt32 colorIndex        []     # [-1, inf)
        field         SFBool  colorPerVertex    TRUE
        field         MFInt32 coordIndex        []     # [-1, inf)
      }

The IndexedLineSet node represents a 3D geometry formed by constructing polylines from 3D vertices specified in the coord field. IndexedLineSet uses the indices in its coordIndex field to specify the polylines by connecting vertices from the coord field. An index of "- 1" indicates that the current polyline has ended and the next one begins. The last polyline may be (but does not have to be) followed by a "- 1". IndexedLineSet is specified in the local coordinate system and is affected by the transformations of its ancestors.

The coord field specifies the 3D vertices of the line set and contains a Coordinate node. Lines are not lit, are not texture-mapped, and do not participate in collision detection. The width of lines is implementation dependent and each line segment is solid (i.e., not dashed). If the color field is not NULL, it shall contain a Color node. The colours are applied to the line(s) as follows:

- If colorPerVertex is FALSE:

- If the colorIndex field is not empty, one colour is used for each polyline of the IndexedLineSet. There shall be at least as many indices in the colorIndex field as there are polylines in the IndexedLineSet. If the greatest index in the colorIndex field is N, there shall be N+1 colours in the Color node. The colorIndex field shall not contain any negative entries.

- If the colorIndex field is empty, the colours from the Color node are applied to each polyline of the IndexedLineSet in order. There shall be at least as many colours in the Color node as there are polylines.

- If colorPerVertex is TRUE:

- If the colorIndex field is not empty, colours are applied to each vertex of the IndexedLineSet in exactly the same manner that the coordIndex field is used to supply coordinates for each vertex from the Coordinate node. The colorIndex field shall contain at least as many indices as the coordIndex field and shall contain end-of-polyline markers (-1) in exactly the same places as the coordIndex field. If the greatest index in the colorIndex field is N, there shall be N+1 colours in the Color node.

- If the colorIndex field is empty, the coordIndex field is used to choose colours from the Color node. If the greatest index in the coordIndex field is N, there shall be N+1 colours in the Color node.

If the color field is NULL and there is a Material defined for the Appearance affecting this IndexedLineSet, the emissiveColor of the Material shall be used to draw the lines. Details on lighting equations as they affect IndexedLineSet nodes are described in 4.14, Lighting model (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.14>).

## Public Member Functions
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
## Static Public Member Functions
void | initClass (void)
## Protected Member Functions
virtual void | generatePrimitives (SoAction *action)

## Member Function Documentation

void SoVRMLIndexedLineSet::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoVRMLIndexedLine.

void SoVRMLIndexedLineSet::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoVRMLVertexLine.

void SoVRMLIndexedLineSet::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

void SoVRMLIndexedLineSet::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

| Action method for the SoGetBoundingBoxAction. Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node. Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables. Reimplemented from SoVRMLVertexLine.

void SoVRMLIndexedLineSet::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

| The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().) The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller. Implements SoShape.

The documentation for this class was generated from the following files:

- SoVRMLIndexedLineSet.h
- IndexedLineSet.cpp